/* eslint-disable no-unused-vars */
import express, { Request, Response, NextFunction } from 'express'
import cors from 'cors'
import swaggerValidation from 'express-ajv-swagger-validation'

import * as schemas from './schemas.d'
import * as responses from './responses.d'

<%
for (const tag of $.tags) {
  %><%- `import * as ${tag.name} from './controllers/${tag.name}'\n` %><%
}
-%>
/* eslint-enable no-unused-vars */

swaggerValidation.init('<%- options.path %>')

const app = express()

app.use(express.json())
app.use(cors()) // TODO:: 本番環境ではもっと具体的に許可するサーバーを絞ったほうがよい
<%
const paths = $.paths
for (const pathStr of Object.getOwnPropertyNames(paths)) {
  const path = paths[pathStr]
  for (const httpMethod of ["get", "post", "put", "pattch", "delete"]) {
    if (path[httpMethod]) {
      %><%- include('./handler.ejs', {api: path[httpMethod], pathStr, httpMethod}) %><%
    }
  }
}
-%>

/* handle error */
app.use(function (err: Error, req: Request, res: Response, next: NextFunction) {
  /* error log */
  // console.error('------------ Request ------------')
  // console.error(req.url)
  // console.error(req.body)
  console.error('------------ Exception ------------')
  console.error(err)

  if (err instanceof swaggerValidation.InputValidationError) {
    /* Validation Error */
    res.status(400).json({ message: 'Validation Error', errors: err.errors })
  // @ts-ignore
  } else if (err instanceof SyntaxError && err.statusCode === 400) {
    res.status(400).json({ message: 'Invalid JSON' })
  } else {
    /* System Error */
    res.status(500).json({ message: 'System Error' })
  }
})

export default app
